#ifndef RAYTRACER_H
#define RAYTRACER_H

#include "colorfrgb.h"
#include "surface.h"
#include "vector.h"
#include "line.h"
#include <vector>

/* This is a really raw ray tracer optimized for speed.
 * Analogue to 3d-ray tracers which support only triangles, we will hence
 * only support lines.
 */
template <class S, template <typename> class I > class RayTracer {
    public:
        typedef S scene_t;
        typedef I<S> integrator_t;
    private:

        //ColorFRGB integrate( float u, float v ) const;
        //ColorFRGB intersect( float x, float y, float d_x, float d_y ) const;
        integrator_t integrator_;

    public:

        integrator_t &integrator;
        scene_t      &scene;

        RayTracer();
        ~RayTracer();
        void trace( Surface<ColorFRGB> &target ) const;
};

#include "raytracer.cc.h"

#endif // RAYTRACER_H
